Bug 32095 - crond cannot run user crontab @reboot with systemd at boottime
: crond cannot run user crontab @reboot with systemd at boottime
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/vixie-cron)
: unstable
: all Linux
: P3 normal
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2016-05-13 16:55 by
Modified: 2016-05-19 18:32 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2016-05-13 16:55:46
crond не может запустить правило @reboot в пользовательском crontab'е во время
загрузки системы если используется systemd. с init'ом проблема не
воспроизводится. если после загрузки перезапустить crond с помощью `systemctl
restart crond.service`, то правила @reboot выполняются.

Логи:

-- Subject: Unit crond.service has finished start-up
-- Unit crond.service has finished starting up.
May 11 14:06:05 host crond[701]: pam_nologin(crond:account): no conversation
function
May 11 14:06:05 host crond[703]: pam_nologin(crond:account): no conversation
function
May 11 14:06:05 host crond[702]: pam_nologin(crond:account): no conversation
function
May 11 14:06:05 host crond[701]: (CRON) pam_acct_mgmt failed (Authentication
failure)
May 11 14:06:05 host crond[702]: (CRON) pam_acct_mgmt failed (Authentication
failure)
May 11 14:06:05 portlab.po.cs.msu.su crond[703]: (CRON) pam_acct_mgmt failed
(Authentication failure)
------- Comment #1 From 2016-05-17 11:41:32 -------
systemd запускает crond слишком рано: /run/nologin к этому времени, видимо, уже
создан, но ещё не удалён.
------- Comment #2 From 2016-05-17 13:24:49 -------
Наблюдения показывают, что это вероятностный процесс, что неудивительно: crond
может запуститься и после удаления /run/nologin.
------- Comment #3 From 2016-05-17 13:49:16 -------
Поставить ему After=systemd-user-sessions.service ?
------- Comment #4 From 2016-05-17 15:34:49 -------
(В ответ на комментарий №3)
> Поставить ему After=systemd-user-sessions.service ?

в https://github.com/systemd-cron/* используют
Requires=systemd-user-sessions.service
------- Comment #5 From 2016-05-17 15:39:56 -------
(In reply to comment #4)
> (В ответ на комментарий №3)
> > Поставить ему After=systemd-user-sessions.service ?
> 
> в https://github.com/systemd-cron/* используют
> Requires=systemd-user-sessions.service

systemd.git использует только After=systemd-user-sessions.service
------- Comment #6 From 2016-05-19 18:32:54 -------
vixie-cron-4.1.20060426-alt10 -> sisyphus:

* Thu May 19 2016 Dmitry V. Levin <ldv@altlinux> 4.1.20060426-alt10
- crond.service: fixed race condition that affected user crontabs
  (closes: #32095).